# better-metrics

This is an alternative port of Coda Hale's [metrics library][codametrics].

I created this because I did not like the existing [metrics][existingmetrics]
port, which makes too many (bad) assumptions that aren't present in the original
library. However, this is not a 1:1 port either as I have tried to use node
idioms for most things.

[codametrics]:  https://github.com/codahale/metrics
[existingmetrics]: https://github.com/mikejihbe/metrics

## Usage

Here is a simple example that measures the requests / second for a http server:

```js
var metrics = require('better-metrics'));
var meter   = new metrics.Meter();

var http = require('http');
http.createServer(function(req, res) {
  meter.mark();
  res.end('Thanks');
}).listen(3000);
```

Now this just measures things, but does not give you any way to look at the
results. But fear not, logging this information is really simple:

```js
setTimeout(function() {
  console.log(meter.toJSON());
}, 1000);
```

This will print something like this:

## Todo

* Finish Readme : )
